import Vue from "vue";
import MFACOMP from "./index.vue";

const MFAConstructor = Vue.extend(MFACOMP);

const MFA = options => {
    const { UserId, username, EMail, callBack, cancelBack, status = 'login' } = options;
    if (!UserId) throw `UserId is requred.but ${UserId}`
    const id = `MFA${new Date().getTime()}`;
    const instance = new MFAConstructor();
    instance.id = id;
    instance.vm = instance.$mount();
    if (instance.vm.visible) return;
    document.body.appendChild(instance.vm.$el);
    instance.vm.open({ UserId, username, EMail, status });
    instance.vm.$on("success", (Id) => {
        if (callBack) callBack(Id)
    });
    instance.vm.$on("closed", () => {
        if (cancelBack) cancelBack();
        document.body.removeChild(instance.vm.$el);
        instance.vm.$destroy();
    });
    return instance.vm;
}
export default MFA;